
Unit SMl2;

Interface

  Uses Crt;

  Type P=Array [1..24] Of Byte;

  Procedure Tah(Pole:P;         {hracie pole}
                T:Integer;      {cislo tahu}
                Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P2}

  {v poli je:

    0 - volne policko
    1 - ty
    2 - super}

Implementation

const s:array [1..24,1..4] of byte=
                  ((2,8,0,0),
                   (1,3,10,0),
                   (2,4,0,0),
                   (3,5,12,0),
                   (4,6,0,0),
                   (5,7,14,0),
                   (6,8,0,0),
                   (7,1,0,0),
                   (16,10,0,0),
                   (9,11,2,18),
                   (10,12,0,0),
                   (11,13,20,4),
                   (12,14,0,0),
                   (13,15,6,22),
                   (14,16,0,0),
                   (15,9,8,24),
                   (18,24,0,0),
                   (17,19,10,0),
                   (18,20,0,0),
                   (19,21,12,0),
                   (20,22,0,0),
                   (21,23,14,0),
                   (24,22,0,0),
                   (17,23,16,0));
         m:array [1..16,1..3] of byte=
                   ((1,2,3),
                    (3,4,5),
                    (5,6,7),
                    (7,8,1),
                    (9,10,11),
                    (11,12,13),
                    (13,14,15),
                    (15,16,9),
                    (17,18,19),
                    (19,20,21),
                    (21,22,23),
                    (23,24,17),
                    (2,10,18),
                    (4,12,20),
                    (6,14,22),
                    (8,16,24));

         k:array [1..24,1..3] of byte=
                ((1,4,1),(1,13,2),(1,2,3),
                 (2,14,2),(2,3,3),
                 (3,15,2),(3,4,3),
                 (4,16,2),
                 (5,8,1),(5,13,2),(5,6,3),
                 (6,14,2),(6,7,3),
                 (7,15,2),(7,8,3),
                 (8,16,2),
                 (9,12,1),(9,13,2),(9,10,3),
                 (10,14,2),(10,11,3),
                 (11,15,2),(11,12,3),
                 (12,16,2));

(*  Procedure Tah(Pole:P;         {hracie pole}
                T:Integer;      {cislo tahu}
                Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P2}
    Begin
      GotoXY(1,1);Write('Z:');ReadLn(P1);
      GotoXY(1,1);Write('Na:');ReadLn(P2);
    End;*)

   var stav:integer;

  function sgn(a:integer):integer;
  begin
   if a=0 then sgn:=0
          else sgn:=a div abs(a);
  end;

  Procedure Tah(Pole:P;         {hracie pole}
                T:Integer;      {cislo tahu}
                Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P2}

   function pokolo(a:integer):boolean;
   var i:integer;
   begin
    pokolo:=false;
    for i:=1 to 4 do
     if s[a,i]<>0 then
      if pole[s[a,i]]=2 then pokolo:=true;
   end;

   procedure rozp2my(var koniec:boolean);
    var i,j,s1,s2:integer;
   begin
    koniec:=false;
    for i:=1 to 16 do begin
     s1:=pole[m[i,1]]+pole[m[i,2]]+pole[m[i,3]];
     s2:=sgn(pole[m[i,1]])+sgn(pole[m[i,2]])+sgn(pole[m[i,3]]);
     if (s1=2) and (s2=2) then begin
      j:=1;
      while pole[m[i,j]]<>0 do j:=j+1;
      p1:=m[i,j];koniec:=true;exit
     end;
    end;
   end;

   procedure rozp2you(var koniec:boolean);
    var i,j,s1,s2:integer;
   begin
    koniec:=false;
    for i:=1 to 16 do begin
     s1:=pole[m[i,1]]+pole[m[i,2]]+pole[m[i,3]];
     s2:=sgn(pole[m[i,1]])+sgn(pole[m[i,2]])+sgn(pole[m[i,3]]);
     if (s1=4) and (s2=2) then begin
      j:=1;
      while pole[m[i,j]]<>0 do j:=j+1;
      p1:=m[i,j];koniec:=true;exit
     end;
    end;
   end;

   procedure rozpvmy(var koniec:boolean);
   var i,a,b,c,s1,s2,s3,s4:integer;
   begin
    koniec:=false;
    for i:=1 to 24 do begin
     a:=k[i,1];b:=k[i,2];c:=k[i,3];
     s1:=pole[m[a,1]]+pole[m[a,2]]+pole[m[a,3]];
     s2:=sgn(pole[m[a,1]])+sgn(pole[m[a,2]])+sgn(pole[m[a,3]]);
     s3:=pole[m[b,1]]+pole[m[b,2]]+pole[m[b,3]];
     s4:=sgn(pole[m[b,1]])+sgn(pole[m[b,2]])+sgn(pole[m[b,3]]);
     if (s1=1) and (s2=1) and (s3=1) and (s4=1) and (pole[m[a,c]]=0) then begin
      koniec:=true;p1:=m[a,c];exit
     end;
    end;
   end;

   procedure rozpvyou(var koniec:boolean);
   var i,a,b,c,s1,s2,s3,s4:integer;
   begin
    koniec:=false;
    for i:=1 to 24 do begin
     a:=k[i,1];b:=k[i,2];c:=k[i,3];
     s1:=pole[m[a,1]]+pole[m[a,2]]+pole[m[a,3]];
     s2:=sgn(pole[m[a,1]])+sgn(pole[m[a,2]])+sgn(pole[m[a,3]]);
     s3:=pole[m[b,1]]+pole[m[b,2]]+pole[m[b,3]];
     s4:=sgn(pole[m[b,1]])+sgn(pole[m[b,2]])+sgn(pole[m[b,3]]);
     if (s1=2) and (s2=1) and (s3=2) and (s4=1) and (pole[m[a,c]]=0) then begin
      koniec:=true;p1:=m[a,c];exit
     end;
    end;
   end;

   function v(a,b,c,d,e,f,g,h,i:integer):boolean;
   begin
    v:=true;
    if (a<>0) then
     if (pole[a]<>0) then v:=false;
    if (b<>0) then
     if (pole[b]<>0) then v:=false;
    if (c<>0) then
     if (pole[c]<>0) then v:=false;
    if (d<>0) then
     if (pole[d]<>0) then v:=false;
    if (e<>0) then
     if (pole[e]<>0) then v:=false;
    if (f<>0) then
     if (pole[f]<>0) then v:=false;
    if (g<>0) then
     if (pole[g]<>0) then v:=false;
    if (h<>0) then
     if (pole[h]<>0) then v:=false;
    if (i<>0) then
     if (pole[i]<>0) then v:=false;
   end;

   procedure taktika;
   var koniec:boolean;
   begin
    koniec:=false;
    rozp2my(koniec);
    if koniec then exit;
    rozp2you(koniec);
    if koniec then exit;
    rozpvmy(koniec);
    if koniec then exit;
    repeat
     case stav of
      10:begin p1:=16;stav:=20;exit end;
      20:if pokolo(16) then stav:=30
                       else stav:=350;
      30:begin p1:=12;stav:=35;exit end;
      35:if pokolo(12) then stav:=40
                       else stav:=260;
      40:begin
          if v(9,15,14,13,11,0,0,0,0) then stav:=50
          else
           if v(15,9,10,11,13,0,0,0,0) then stav:=70
           else
            if v(20,24,1,8,7,6,5,4,3) then stav:=90
            else
             if v(20,24,1,2,3,4,5,7,8) then stav:=130
             else
              if v(4,8,19,20,21,22,23,24,17) then stav:=170
              else
               if v(4,8,19,20,18,17,24,23,21) then stav:=210
               else
                if (pole[8]=2) or (pole[13]=2) then stav:=440;

          end;
      50:begin p1:=15;stav:=60;exit end;
      60:begin p1:=13;stav:=250;exit end;
      70:begin p1:=9;stav:=80;exit end;
      80:begin p1:=11;stav:=250;exit end;
      90:begin p1:=8;stav:=100;exit end;
      100:begin p1:=4;stav:=110;exit end;
      110:begin p1:=7;stav:=120;exit end;
      120:begin p1:=5;stav:=250;exit end;
      130:begin p1:=8;stav:=140;exit end;
      140:begin p1:=4;stav:=150;exit end;
      150:begin p1:=1;stav:=160;exit end;
      160:begin p1:=3;stav:=250;exit end;
      170:begin p1:=20;stav:=180;exit end;
      180:begin p1:=24;stav:=190;exit end;
      190:begin p1:=21;stav:=200;exit end;
      200:begin p1:=23;stav:=250;exit end;
      210:begin p1:=20;stav:=220;exit end;
      220:begin p1:=24;stav:=230;exit end;
      230:begin p1:=19;stav:=240;exit end;
      240:begin p1:=17;stav:=250;exit end;
      250:exit;
      260:begin
          rozpvyou(koniec);
          if koniec then stav:=40
          else
          if v(11,13,14,15,3,4,5,6,7) then stav:=270
          else
           if v(1,2,3,4,5,9,10,11,13) then stav:=290
           else
            if v(9,10,11,13,17,18,19,20,21) then stav:=310
            else
             if v(11,13,14,15,17,18,19,20,21) then stav:=330
             else stav:=250;
          end;
      270:begin p1:=5;stav:=280;exit end;
      280:begin p1:=14;stav:=250;exit end;
      290:begin p1:= 3;stav:=300;exit end;
      300:begin p1:=10;stav:=250;exit end;
      310:begin p1:=19;stav:=320;exit end;
      320:begin p1:=10;stav:=250;exit end;
      330:begin p1:=21;stav:=330;exit end;
      340:begin p1:=22;stav:=250;exit end;
      350:if v(13,14,15,9,5,6,7,8,1) then stav:=360
          else
           if v(1,2,3,7,8,11,10,9,15) then stav:=380
           else
            if v(11,10,9,15,24,23,17,18,9) then stav:=400
            else
             if v(17,23,24,22,21,9,15,14,13) then stav:=420
             else stav:=250;
      360:begin p1:=7;stav:=370;exit; end;
      370:begin p1:=22;stav:=250;exit; end;
      380:begin p1:= 1;stav:=390;exit; end;
      390:begin p1:=10;stav:=250;exit; end;
      400:begin p1:=17;stav:=410;exit; end;
      410:begin p1:=10;stav:=250;exit; end;
      420:begin p1:=14;stav:=430;exit; end;
      430:begin p1:=23;stav:=250;exit; end;
      440:begin p1:=20;stav:=450;exit; end;
      450:begin p1:=19;stav:=460;exit; end;
      460:begin p1:=9;stav:=470;exit;end;
      470:begin p1:=18;stav:=250;exit end;
     end;
    until false;
   end;
  begin
   if t=1 then stav:=10;
   taktika;
  end;
begin
 nosound;
 directvideo:=false;

End.