
Unit SMl1;

Interface

  Uses Crt;

  Type P=Array [1..24] Of Byte;

  Procedure Tah(Pole:P;         {hracie pole}
                T:Integer;      {cislo tahu}
                Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P2}

  {v poli je:

    0 - volne policko
    1 - ty
    2 - super}

Implementation

  {$B-}

  Const A:array[1..16,1..3] of integer =
    ((1,2,3), (3,4,5), (5,6,7), (7,8,1),
     (9,10,11), (11,12,13), (13,14,15), (15,16,9),
     (17,18,19), (19,20,21), (21,22,23), (23,24,17),
     (2,10,18), (4,12,20), (6,14,22), (8,16,24));

  Const B:array[1..24,1..4] of integer =
    ((2,3,8,7), (1,3,10,18), (1,2,4,5), (12,20,3,5),
     (6,7,3,4), (7,5,22,14), (6,5,1,8), (16,24,1,7),
     (10,11,16,15), (9,11,2,18), (9,10,12,13), (4,20,11,13),
     (14,15,11,12), (13,15,22,6), (14,13,9,16), (8,24,9,15),
     (18,19,24,23), (17,19,2,10), (17,18,20,21), (12,4,19,21),
     (22,23,19,20), (21,23,14,6), (21,22,17,24), (8,16,17,23));

  Const C:array[1..24,1..4] of integer =
    ((0,8,2,0),(1,10,3,0),(2,4,0,0),(12,5,0,3),(6,0,0,4),(7,0,5,14),
     (0,0,6,8),(0,7,16,1),(0,16,10,0),(9,18,11,2),(10,12,0,0),(20,13,4,11),
     (14,0,0,12),(15,6,13,22),(0,0,14,16),(8,15,24,9),(0,24,18,0),(17,0,19,10),
     (18,20,0,0),(0,21,12,19),(22,0,0,20),(23,14,21,0),(0,0,22,24),(16,23,0,17));

  Procedure Tah(Pole:P;         {hracie pole}
                T:Integer;      {cislo tahu}
                Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P1}

    Function Pol(i,smer:integer):integer;
    begin
      if C[i,smer] <> 0 then Pol := Pole[C[i,smer]] else Pol := -1;
    end;

    Procedure ZistiTypy(i:integer; var typ1,typ2:integer);
    var pp:integer;
    begin
      if Pole[B[i,1]]+Pole[B[i,2]]=0 then typ1:=1
        else if Pole[B[i,1]]+Pole[B[i,2]]=1 then typ1:=2
        else if Pole[B[i,1]]+Pole[B[i,2]]=4 then typ1:=6
        else if Pole[B[i,1]]+Pole[B[i,2]]=3 then typ1:=5
        else if Pole[B[i,1]]=1 then typ1:=4 else typ1:=3;

      if Pole[B[i,3]]+Pole[B[i,4]]=0 then typ2:=1
        else if Pole[B[i,3]]+Pole[B[i,4]]=1 then typ2:=2
        else if Pole[B[i,3]]+Pole[B[i,4]]=4 then typ2:=6
        else if Pole[B[i,3]]+Pole[B[i,4]]=3 then typ2:=5
        else if Pole[B[i,3]]=1 then typ2:=4 else typ2:=3;

      if typ1 > typ2 then begin pp:=typ1; typ1:=typ2; typ2:=pp end;
    end;

    Var i,j,i1,i2,i3,i4,i5,pr,h,max,maxi,maxj,typ1,typ2:integer;
        prio:array[1..24] of integer;
        pr2:array[1..24,1..4] of integer;

    Begin
      P1 := 0;

      if T>18 then begin
        for i:=1 to 24 do for j:=1 to 4 do pr2[i,j] := 0;
        for i:=1 to 24 do
          if Pole[i] = 0 then
            for j:=1 to 4 do
              if C[i,j]<>0 then
                if Pole[C[i,j]]=1 then begin
                  i4 := ((j+1) mod 4)+1;
                  i5 := C[i,j];
                  if (j=1) or (j=3) then begin i1:=2; i2:=4; i3:=3 end
                    else begin i1:=1; i2:=3; i3:=1 end;

                  if (Pole[B[i,i3]]=1) and (Pole[B[i,i3+1]]=1) then
                     inc(pr2[i,j],5)
                  else if (Pole[B[i,i3]]=2) and (Pole[B[i,i3+1]]=2) and
                       (C[i,i4]<>0) and (Pole[C[i,i4]]=2) then
                         inc(pr2[i,j],4)
                  else if(Pole[B[i5,i3]]=2) and (Pole[B[i5,i3+1]]=2) and
                         (C[i5,j]<>0) and (Pole[C[i5,j]]=2) then
                           begin end
                  else inc(pr2[i,j],2);
                end;

        maxi := 1; maxj := 1; i1 := 1;
        for i:=1 to 24 do
          for j:=1 to 4 do
            if pr2[i,j] > pr2[maxi,maxj] then begin
              maxi:=i; maxj:=j; i1:=1 end
          else if pr2[i,j] = pr2[maxi,maxj] then inc(i1);

        if i1 > 1 then begin
          i1 := Random(i1) + 1;
          for i:=1 to 24 do
            for j:=1 to 4 do
              if pr2[i,j] = pr2[maxi,maxj] then begin
                dec(i1);
                if i1 = 0 then begin maxi := i; maxj := j end
              end
        end;

        P1 := C[maxi,maxj]; P2 := maxi;
{        GotoXY(1,1); Write(maxi,' ',maxj,' ',pr2[maxi,maxj],'     '); }

      end else if T=1 then P1 := 10
      else begin
        max := 0; maxi := 0;

        for i:=1 to 24 do prio[i] := 0;
        for i:=1 to 24 do
          if Pole[i] = 0 then begin
            ZistiTypy(i, typ1, typ2);
            if (typ1=4) or (typ2=4) then pr := 50
            else if (typ1=6) or (typ2=6) then pr := 40
            else if (typ1=2) and (typ2=2) then pr := 20
            else if (typ1=3) and (typ2=3) then pr := 19
            else if (typ1=1) and (typ2=3) then begin
              if (T=2) or (T=4) then pr := 13
              else if T in [3,5,7,9] then pr := 0
              else pr := 2
            end else if (typ1=5) and (typ2=5) then pr := 1
            else if (typ1=1) and (typ2=2) then begin
              pr := 0;
              if (Pole[B[i,1]]=0) and (Pole[B[i,2]]=0) then begin
                inc(prio[B[i,1]], 4);
                inc(prio[B[i,2]], 4)
              end else begin inc(prio[B[i,3]], 4); inc(prio[B[i,4]], 4) end
            end else pr := 2;

            prio[i] := prio[i] + pr;
          end;

        for i:=1 to 24 do begin
          if prio[i] > max then begin max := prio[i]; maxi := i end
          else if prio[i] = max then if Random(2)=0 then maxi := i;
        end;
        P1 := maxi
      end;

    End;

End.