
Unit SMl2;

Interface

  Uses Crt;

  Type P=Array [1..24] Of Byte;

  Procedure Tah(Pole:P;         {hracie pole}
                T:Integer;      {cislo tahu}
                Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P1}

  {v poli je:

    0 - volne policko
    1 - ty
    2 - super}

Implementation

const s:array [1..24,1..4] of byte=
                  ((2,8,0,0),
                   (1,3,10,0),
                   (2,4,0,0),
                   (3,5,12,0),
                   (4,6,0,0),
                   (5,7,14,0),
                   (6,8,0,0),
                   (7,1,0,0),
                   (16,10,0,0),
                   (9,11,2,18),
                   (10,12,0,0),
                   (11,13,20,4),
                   (12,14,0,0),
                   (13,15,6,22),
                   (14,16,0,0),
                   (15,9,8,24),
                   (18,24,0,0),
                   (17,19,10,0),
                   (18,20,0,0),
                   (19,21,12,0),
                   (20,22,0,0),
                   (21,23,14,0),
                   (24,22,0,0),
                   (17,23,16,0));
         m:array [1..16,1..3] of byte=
                   ((1,2,3),
                    (3,4,5),
                    (5,6,7),
                    (7,8,1),
                    (9,10,11),
                    (11,12,13),
                    (13,14,15),
                    (15,16,9),
                    (17,18,19),
                    (19,20,21),
                    (21,22,23),
                    (23,24,17),
                    (2,10,18),
                    (4,12,20),
                    (6,14,22),
                    (8,16,24));

         k:array [1..24,1..3] of byte=
                ((1,4,1),(1,13,2),(1,2,3),
                 (2,14,2),(2,3,3),
                 (3,15,2),(3,4,3),
                 (4,16,2),
                 (5,8,1),(5,13,2),(5,6,3),
                 (6,14,2),(6,7,3),
                 (7,15,2),(7,8,3),
                 (8,16,2),
                 (9,12,1),(9,13,2),(9,10,3),
                 (10,14,2),(10,11,3),
                 (11,15,2),(11,12,3),
                 (12,16,2));

(*  Procedure Tah(Pole:P;         {hracie pole}
                  T:Integer;      {cislo tahu}
                  Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P2}
    Begin
      GotoXY(1,1);Write('Z:');ReadLn(P1);
      GotoXY(1,1);Write('Na:');ReadLn(P2);
    End;*)

   var stav:integer;
       inv:boolean;

  function sgn(a:integer):integer;
  begin
   if a=0 then sgn:=0
          else sgn:=a div abs(a);
  end;

  Procedure Tah(Pole:P;         {hracie pole}
                T:Integer;      {cislo tahu}
                Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P2}

   function pokolo(a:integer):boolean;
   var i:integer;
   begin
    pokolo:=false;
    for i:=1 to 4 do
     if s[a,i]<>0 then
      if pole[s[a,i]]=2 then pokolo:=true;
   end;

   procedure rozp2my(var koniec:boolean);
    var i,j,s1,s2:integer;
   begin
    koniec:=false;
    for i:=1 to 16 do begin
     s1:=pole[m[i,1]]+pole[m[i,2]]+pole[m[i,3]];
     s2:=sgn(pole[m[i,1]])+sgn(pole[m[i,2]])+sgn(pole[m[i,3]]);
     if (s1=2) and (s2=2) then begin
      j:=1;
      while pole[m[i,j]]<>0 do j:=j+1;
      p1:=m[i,j];koniec:=true;exit
     end;
    end;
   end;

   procedure rozp2you(var koniec:boolean);
    var i,j,s1,s2:integer;
   begin
    koniec:=false;
    for i:=1 to 16 do begin
     s1:=pole[m[i,1]]+pole[m[i,2]]+pole[m[i,3]];
     s2:=sgn(pole[m[i,1]])+sgn(pole[m[i,2]])+sgn(pole[m[i,3]]);
     if (s1=4) and (s2=2) then begin
      j:=1;
      while pole[m[i,j]]<>0 do j:=j+1;
      p1:=m[i,j];koniec:=true;exit
     end;
    end;
   end;

   function mlynmy:boolean;
    var i,j,s1,s2:integer;
   begin
    mlynmy:=false;
    for i:=1 to 16 do begin
     s1:=pole[m[i,1]]+pole[m[i,2]]+pole[m[i,3]];
     s2:=sgn(pole[m[i,1]])+sgn(pole[m[i,2]])+sgn(pole[m[i,3]]);
     if (s1=3) and (s2=3) then begin
      mlynmy:=true;exit
     end;
    end;
   end;

   function mlynyou:boolean;
    var i,j,s1,s2:integer;
   begin
    mlynyou:=false;
    for i:=1 to 16 do begin
     s1:=pole[m[i,1]]+pole[m[i,2]]+pole[m[i,3]];
     s2:=sgn(pole[m[i,1]])+sgn(pole[m[i,2]])+sgn(pole[m[i,3]]);
     if (s1=3) and (s2=6) then begin
      mlynyou:=true;exit
     end;
    end;
   end;

   procedure rozpvmy(var koniec:boolean);
   var i,a,b,c,s1,s2,s3,s4:integer;
   begin
    koniec:=false;
    for i:=1 to 24 do begin
     a:=k[i,1];b:=k[i,2];c:=k[i,3];
     s1:=pole[m[a,1]]+pole[m[a,2]]+pole[m[a,3]];
     s2:=sgn(pole[m[a,1]])+sgn(pole[m[a,2]])+sgn(pole[m[a,3]]);
     s3:=pole[m[b,1]]+pole[m[b,2]]+pole[m[b,3]];
     s4:=sgn(pole[m[b,1]])+sgn(pole[m[b,2]])+sgn(pole[m[b,3]]);
     if (s1=1) and (s2=1) and (s3=1) and (s4=1) and (pole[m[a,c]]=0) then begin
      koniec:=true;p1:=m[a,c];exit
     end;
    end;
   end;

   procedure rozpvyou(var koniec:boolean);
   var i,a,b,c,s1,s2,s3,s4:integer;
   begin
    koniec:=false;
    for i:=1 to 24 do begin
     a:=k[i,1];b:=k[i,2];c:=k[i,3];
     s1:=pole[m[a,1]]+pole[m[a,2]]+pole[m[a,3]];
     s2:=sgn(pole[m[a,1]])+sgn(pole[m[a,2]])+sgn(pole[m[a,3]]);
     s3:=pole[m[b,1]]+pole[m[b,2]]+pole[m[b,3]];
     s4:=sgn(pole[m[b,1]])+sgn(pole[m[b,2]])+sgn(pole[m[b,3]]);
     if (s1=2) and (s2=1) and (s3=2) and (s4=1) and (pole[m[a,c]]=0) then begin
      koniec:=true;p1:=m[a,c];exit
     end;
    end;
   end;



   function  rekurzia(kolko,kto,tah:byte;
                      var t1,t2:byte):byte;{0 -neviem
                                            1 -vyhra 1
                                            2 -vyhra 2}
    var uz:boolean;
        r,x,i,j:integer;
        fn1,fn2:byte;
        koniec:boolean;

    procedure prvytah(var i,j:integer;
                      var koniec:boolean);
    var fn:integer;
    begin
     if tah<=18 then begin
      j:=0;
      if pole[i]=0 then koniec:=false
                   else koniec:=true;
     end
     else begin
      j:=1;
      while (j<=4) and (s[i,j]>0) do begin
       if pole[s[i,j]]=kto then begin koniec:=false;exit end;
       j:=j+1;
      end;
      j:=0;
      koniec:=true;
     end;
    end;

    procedure dalsitah(var i,j:integer;
                       var koniec:boolean);
    begin
     if j=0 then begin koniec:=true;exit;end;
     j:=j+1;
     while (j<=4) and (s[i,j]>0) do begin
      if pole[s[i,j]]=kto then begin koniec:=false;exit end;
      j:=j+1;
     end;
     j:=0;
     koniec:=true;
    end;

    procedure urobtah(i,j:integer);
    begin
     if j<>0 then begin
      pole[s[i,j]]:=0;
      pole[i]:=kto;
     end
     else pole[i]:=kto;
    end;

    procedure odrobtah(i,j:integer);
    begin
     if j<>0 then begin
      pole[s[i,j]]:=kto;
      pole[i]:=0;
     end
     else pole[i]:=0;
    end;

   begin
    if mlynmy then begin rekurzia:=1;exit end;
    if mlynyou then begin rekurzia:=2;exit end;
    if kolko=0 then begin rekurzia:=0;{writeln('spat')};exit end;
    uz:=false;r:=3-kto;
    for i:=1 to 24 do begin
     prvytah(i,j,koniec);
     while not(koniec) do begin
      urobtah(i,j);
      x:=rekurzia(kolko-1,3-kto,tah+1,fn1,fn2);
      odrobtah(i,j);
      if not(uz) then begin r:=x;t1:=i;t2:=j end
      else begin
       if r=x then
        if random(2)=1 then begin r:=x;t1:=i;t2:=j end
                       else begin end
        else
         if (r=0) and (x=kto) then begin r:=x;t1:=i;t2:=j end
         else
          if (r=3-kto) and ((x=kto) or (x=0)) then begin r:=x;t1:=i;t2:=j;end;
      end;
      dalsitah(i,j,koniec);
     end;
    end;
    rekurzia:=r;
   end;




   function v(a,b,c,d,e,f,g,h,i:integer):boolean;
   begin
    v:=true;
    if (a<>0) then
     if (pole[a]<>0) then v:=false;
    if (b<>0) then
     if (pole[b]<>0) then v:=false;
    if (c<>0) then
     if (pole[c]<>0) then v:=false;
    if (d<>0) then
     if (pole[d]<>0) then v:=false;
    if (e<>0) then
     if (pole[e]<>0) then v:=false;
    if (f<>0) then
     if (pole[f]<>0) then v:=false;
    if (g<>0) then
     if (pole[g]<>0) then v:=false;
    if (h<>0) then
     if (pole[h]<>0) then v:=false;
    if (i<>0) then
     if (pole[i]<>0) then v:=false;
   end;

   procedure taktika;
   var koniec:boolean;
       fnnn:integer;

    function ffn(i:byte):byte;
    begin
     if inv then begin
      case i of
       1..8:ffn:=i+16;
       9..16:ffn:=i;
       17..24:ffn:=i-16;
      end;
     end
     else ffn:=i;
    end;

    function fin(i:byte):byte;
    begin
     if inv then
      case i of
       1,2,3,5,6,7:fin:=8-i;
       9,10,11,13,14,15:fin:=16-i;
       17,18,19,21,22,23:fin:=24-i;
       8,16,24,20,12,4:fin:=i;
      end
     else fin:=i;
    end;

   begin
    koniec:=false;
    rozp2my(koniec);
    if koniec then exit;
    rozp2you(koniec);
    if koniec then exit;
    rozpvmy(koniec);
    if koniec then exit;
    repeat
     case stav of
      10:begin p1:=16;stav:=20;exit end;
      20:case p1 of
          1:stav:=30;
          7:stav:=80;
          2,3,4,10,12:stav:=120;
          6,5,14:stav:=160;
          11:stav:=200;
          13:stav:=240;
          8:begin inv:=false;stav:=280;end;
          24:begin inv:=true;stav:=280;end;
          9:begin inv:=false;stav:=390;end;
          15:begin inv:=true;stav:=390;end;
         end;
      30:begin p1:=15;stav:=40;exit end;
      40:begin p1:=14;stav:=50;exit end;
      50:begin p1:=22;stav:=60;exit end;
      60:begin p1:=23;stav:=999;exit end;
      80:begin p1:=9;stav:=90;exit end;
      90:begin p1:=10;stav:=100;exit end;
      100:begin p1:=18;stav:=110;exit end;
      110:begin p1:=17;stav:=999;exit end;
      120:begin p1:=24;stav:=130;exit end;
      130:begin p1:=23;stav:=140;exit end;
      140:begin p1:=22;stav:=150;exit end;
      150:begin p1:=14;stav:=999;exit end;
      160:begin p1:=24;stav:=170;exit end;
      170:begin p1:=17;stav:=180;exit end;
      180:begin p1:=18;stav:=190;exit end;
      190:begin p1:=10;stav:=999;exit end;
      200:begin p1:= 8;stav:=210;exit end;
      210:begin p1:= 7;stav:=220;exit end;
      220:begin p1:= 6;stav:=230;exit end;
      230:begin p1:=14;stav:=999;exit end;
      240:begin p1:= 8;stav:=250;exit end;
      250:begin p1:= 1;stav:=260;exit end;
      260:begin p1:= 2;stav:=270;exit end;
      270:begin p1:=10;stav:=999;exit end;
      280:begin p1:=12;stav:=290;exit end;
      290:if p1 in [ffn(20),ffn(4),ffn(3),ffn(5),ffn(19),ffn(21),ffn(2),ffn(6),ffn(18),ffn(22),ffn(17),ffn(23),ffn(24)]
          then stav:=300
          else
           if p1 in [ffn(11),ffn(9),ffn(10)] then stav:=310
           else
            if p1 in [ffn(15),ffn(13),ffn(14)] then stav:=350
            else
             stav:=999;
      300:begin p1:=ffn(13);stav:=999;exit end;
      310:begin
           p1:=ffn(20);stav:=320;exit end;
      320:begin p1:=ffn(21);stav:=330;exit end;
      330:begin p1:=ffn(22);stav:=340;exit end;
      340:begin p1:=ffn(14);stav:=999;exit end;
      350:begin p1:=ffn(20);stav:=360;exit end;
      360:begin p1:=ffn(19);stav:=370;exit end;
      370:begin p1:=ffn(18);stav:=380;exit end;
      380:begin p1:=ffn(10);stav:=999;exit end;
      390:begin p1:=12;stav:=400;exit end;
      400:if p1 in [fin(1),fin(2),fin(8)] then stav:=410
           else
           if p1 in [fin(3)] then stav:=450
            else
            if p1=fin(4) then stav:=490
             else
             if p1=fin(5) then stav:=530
              else
              if p1=fin(6) then stav:=560
               else
               if p1=fin(7) then stav:=590
               else
                if p1=fin(8) then stav:=620
                else
                 if p1 in [fin(13),fin(14),fin(15)] then stav:=660
                  else
                  if p1 in [fin(17),fin(18),fin(24)] then stav:=700
                   else
                   if p1=fin(19) then stav:=740
                    else
                     if p1=fin(20) then stav:=780
                     else
                      if p1=fin(21) then stav:=820
                      else
                       if p1=fin(22) then stav:=850
                       else
                        if p1=fin(23) then stav:=880
                    else stav:=999;


      410:begin p1:=fin(20);stav:=420;exit end;
      420:begin p1:=fin(21);stav:=430;exit end;
      430:begin p1:=fin(22);stav:=440;exit end;
      440:begin p1:=fin(14);stav:=999;exit end;
      450:begin p1:=fin(13);stav:=460;exit end;
      460:begin p1:=fin(14);stav:=470;exit end;
      470:begin p1:=fin(22);stav:=480;exit end;
      480:begin p1:=fin(21);stav:=999;exit end;
      490:begin p1:=fin(24);stav:=500;exit end;
      500:begin p1:=fin(23);stav:=510;exit end;
      510:begin p1:=fin(22);stav:=520;exit end;
      520:begin p1:=fin(14);stav:=999;exit end;
      530:begin p1:=fin(24);stav:=540;exit end;
      540:begin p1:=fin(23);stav:=550;exit end;
      550:begin p1:=fin(21);stav:=999;exit end;
      560:begin p1:=fin(24);stav:=570;exit end;
      570:begin p1:=fin(17);stav:=580;exit end;
      580:begin p1:=fin(19);stav:=999;exit end;
      590:begin p1:=fin(20);stav:=600;exit end;
      600:begin p1:=fin(21);stav:=610;exit end;
      610:begin p1:=fin(23);stav:=999;exit end;
      620:begin p1:=fin(20);stav:=630;exit end;
      630:begin p1:=fin(21);stav:=640;exit end;
      640:begin p1:=fin(22);stav:=650;exit end;
      650:begin p1:=fin(14);stav:=999;exit end;
      660:begin p1:=fin( 4);stav:=670;exit end;
      670:begin p1:=fin( 8);stav:=680;exit end;
      680:begin p1:=fin( 7);stav:=690;exit end;
      690:begin p1:=fin( 5);stav:=999;exit end;
      700:begin p1:=fin( 4);stav:=710;exit end;
      710:begin p1:=fin( 5);stav:=720;exit end;
      720:begin p1:=fin( 6);stav:=730;exit end;
      730:begin p1:=fin(14);stav:=999;exit end;
      740:begin p1:=fin(13);stav:=750;exit end;
      750:begin p1:=fin(14);stav:=760;exit end;
      760:begin p1:=fin( 6);stav:=770;exit end;
      770:begin p1:=fin( 5);stav:=999;exit end;
      780:begin p1:=fin( 8);stav:=790;exit end;
      790:begin p1:=fin( 7);stav:=800;exit end;
      800:begin p1:=fin( 6);stav:=810;exit end;
      810:begin p1:=fin(14);stav:=999;exit end;
      820:begin p1:=fin( 8);stav:=830;exit end;
      830:begin p1:=fin( 7);stav:=840;exit end;
      840:begin p1:=fin( 5);stav:=999;exit end;
      850:begin p1:=fin( 8);stav:=860;exit end;
      860:begin p1:=fin( 1);stav:=870;exit end;
      870:begin p1:=fin( 3);stav:=999;exit end;
      880:begin p1:=fin( 4);stav:=890;exit end;
      890:begin p1:=fin( 5);stav:=900;exit end;
      900:begin p1:=fin( 7);stav:=999;exit end;
      999:begin fnnn:=rekurzia(1,1,t,p1,p2);
                if p2<>0 then begin
                 fnnn:=p2;p2:=p1;p1:=s[p1,fnnn];end;
                exit;
          end;
     end;
    until false;
   end;

  begin
   if t=1 then stav:=10;
   if t=2 then stav:=999;
   taktika;
  end;
begin
 nosound;
 directvideo:=false;

End.