
Unit SMl5;
{Erika}

Interface

  Uses Crt;

  Type P=Array [1..24] Of Byte;

  Procedure Tah(Pole:P;         {hracie pole}
                T:Integer;      {cislo tahu}
                Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P1}

  {v poli je:

    0 - volne policko
    1 - ty
    2 - super}

Implementation

  Const MlynS:Array [0..16,1..3] Of Byte=((0,0,0),
         (1,2,3),(3,4,5),(5,6,7),(7,8,1),
         (9,10,11),(11,12,13),(13,14,15),(15,16,9),
         (17,18,19),(19,20,21),(21,22,23),(23,24,17),
         (2,10,18),(8,16,24),(6,14,22),(4,12,20));

  Procedure Tah(Pole:P;         {hracie pole}
                T:Integer;      {cislo tahu}
                Var P1,P2:Byte);{posun z P1 na P2, resp. polozit na P2}

    Var Mlyn:Boolean;

    Function Nemozno(Z,Na:ShortInt):Boolean;
      {testuje, ci nemozno prejst zo Z na Na}
      Begin
        Nemozno:=False;
        If (T<19) And (Pole[Z]=0) Then Exit;
        If (Z<1) Or (Z>24) Or (Na<1) Or (Na>24) Then Begin
          Nemozno:=True;Mlyn:=False;Exit;End;
        If (Pole[Z]=0) Or (Pole[Na]<>0) Then Begin
          Nemozno:=True;Mlyn:=False;Exit;End;
        If (Z-Na=1) And (Z In [9,17]) Then Begin
          Nemozno:=True;Mlyn:=False;Exit;End;
        If (Na-Z=1) And (Na In [9,17]) Then Begin
          Nemozno:=True;Mlyn:=False;Exit;End;
        If Abs(Z-Na)=1 Then Exit;
        If (Abs(Z-Na)=8) And (Z Mod 2=0) Then Exit;
        If (Z In [1,9,17]) And (Na-Z=7) Then Exit;
        If (Na In [1,9,17]) And (Z-Na=7) Then Exit;
        Nemozno:=True;Mlyn:=False;
      End;

    Function Odkial(N,S:Byte):Byte; {startuje od S}
      {testuje, odkial mozno prist z policka X na policko N}
      Var I:Byte;
      Begin
        For I:=S To 24 Do
          If Not(Nemozno(I,N)) And (Pole[I]=1) Then Begin
            Odkial:=I;Exit;End;
      End;

    Function OdkialN(N:Byte):Byte;
      {ako odkial - len testuje najlepsi tah}
      Begin
        {zatial este nie}
        OdkialN:=Odkial(N,1);
      End;

    Function MozeSuper(P,M:Byte):Boolean;
      Var I:Byte;
      Begin
        For I:=1 To 24 Do
          If (Pole[I]=2) And Not(Nemozno(I,P)) Then Begin
            If Not(I In [MlynS[M,1],MlynS[M,2],MlynS[M,3]]) Then Begin
              MozeSuper:=True;Exit;
            End;
          End;
        MozeSuper:=False;
      End;

    Procedure JeMlyn;
      Function Test(C1,C2,C3:Byte):Boolean;
        Var P:Byte;
        Begin
          P:=Pole[C1]+Pole[C2]+Pole[C3];
          If P=4 Then
            If (Pole[C1]=1) Or (Pole[C2]=1) Then Test:=False
              Else Begin
                Test:=True;
                If Pole[C1]=0 Then P2:=C1 Else P2:=C3;
                If Pole[C2]=0 Then P2:=C2;
                If T<19 Then P1:=P2 Else Begin
                  P1:=OdkialN(P2);
                  If (P1<1) Or (P1>24) Or Nemozno(P1,P2) Then Test:=False;
                End;
              End
          Else Test:=False;
        End;
      Begin
        Mlyn:=Test(1,2,3) Or Test(3,4,5) Or Test(5,6,7) Or Test(7,8,1) Or
         Test(9,10,11) Or Test(11,12,13) Or Test(13,14,15) Or Test(15,16,9) Or
         Test(17,18,19) Or Test(19,20,21) Or Test(21,22,23) Or Test(23,24,17) Or
         Test(2,10,18) Or Test(8,16,24) Or Test(6,14,22) Or Test(4,12,20);
      End;

    Procedure JeMojMlyn;
      Function Test(C1,C2,C3:Byte):Boolean;
        Var P:Byte;
        Begin
          P:=Pole[C1]+Pole[C2]+Pole[C3];
          If P=2 Then
            If (Pole[C1]=2) Or (Pole[C2]=2) Or (Pole[C3]=2) Then Test:=False
              Else Begin
                Test:=True;
                If Pole[C1]=0 Then P2:=C1 Else P2:=C3;
                If Pole[C2]=0 Then P2:=C2;
                If T<19 Then P1:=P2 Else Begin
                  P1:=Odkial(P2,1);
                  While (P1>0) And (P1<24) And
                    (P1 In [C1,C2,C3]) Do P1:=Odkial(P2,P1+1);
                  If P1 In [C1,C2,C3] Then P1:=0;
                  Mlyn:=P1>0;
                End;
              End
          Else Test:=False;
        End;
      Begin
        Mlyn:=Test(1,2,3) Or Test(3,4,5) Or Test(5,6,7) Or Test(7,8,1) Or
         Test(9,10,11) Or Test(11,12,13) Or Test(13,14,15) Or Test(15,16,9) Or
         Test(17,18,19) Or Test(19,20,21) Or Test(21,22,23) Or Test(23,24,17) Or
         Test(2,10,18) Or Test(8,16,24) Or Test(6,14,22) Or Test(4,12,20);
      End;

    Procedure TestujL(F:Byte);
      Var I,J:Byte;
      Procedure Test;
        Var K,L:Byte;
        Function Test0(N:Byte):Boolean;
          Var M:Array [1..3] Of Byte;
              P:Byte;
          Begin
            Move(MlynS[N],M,3);
            P:=Pole[M[1]]+Pole[M[2]]+Pole[M[3]];
            If F=2 Then Begin
              If (Pole[M[1]]=1) Or (Pole[M[2]]=1) Then P:=0;
            End;
            Test0:=P=F;
          End;
        Begin
          If Test0(I) And Test0(J) Then
            Begin
              For K:=1 To 3 Do
                For L:=1 To 3 Do
                  If MlynS[I,K]=MlynS[J,L] Then Begin
                    If Pole[MlynS[I,K]]=0 Then Begin
                      If T<19 Then Begin
                        P1:=MlynS[I,K];
                        If (F=2) And (P1 In [1,3,5,7,17,19,21,23]) Then Begin
                          If Pole[MlynS[I,2]]=0 Then P1:=MlynS[I,2]
                            Else If Pole[MlynS[J,2]]=0 Then P1:=MlynS[J,2];
                        End;
                        Mlyn:=True;
                        Exit;
                      End Else Begin
                        P2:=MlynS[I,K];
                        P1:=OdkialN(P2);
                        If P1<>0 Then Begin
                          Mlyn:=True;
                          If (F=2) And (T>18) Then Mlyn:=MozeSuper(P2,I);
                          Exit;
                        End;
                      End;
                    End;
                    Exit;
                  End;
            End;
        End;
      Begin
        For I:=1 To 15 Do
          For J:=I+1 To 16 Do
            Begin Test;If Mlyn Then Exit;End;
      End;

    Procedure Testuj2(F:Byte);
      Var I,P:Byte;
          M:Array [1..3] Of Byte;
      Begin
        For I:=1 To 16 Do
          Begin
            Move(MlynS[I],M,3);
            P:=Pole[M[1]]+Pole[M[2]]+Pole[M[3]];
            If F=2 Then Begin
              If (Pole[M[1]]=1) Or (Pole[M[2]]=1) Then P:=0;
            End;
            If P=F Then Begin
              If Pole[M[2]]=0 Then P1:=M[2] Else
                If Pole[M[1]]=0 Then P1:=M[1] Else P1:=M[3];
              If T<19 Then Mlyn:=True Else
                Begin
                  P2:=P1;
                  P1:=OdkialN(P2);
                  If P1<>0 Then Mlyn:=True;
                End;
            End;
          End;
      End;

    Procedure TestujW(F:Byte);
      Const P:Array [1..12] Of Byte=(4,8,12,10,6,2,1,5,9,11,7,3);
            M:Array [1..12] Of Byte=(14,14,14,16,16,16,13,13,13,15,15,15);
      Var Pp,I,J:Byte;
      Function Test0(N:Byte):Boolean;
        Begin
          Test0:=Pole[MlynS[N,1]]+Pole[MlynS[N,2]]+Pole[MlynS[N,3]]=F;
        End;
      Function Prazdne(N:Byte):Boolean;
        Begin
          Prazdne:=Pole[MlynS[N,1]]+Pole[MlynS[N,2]]+Pole[MlynS[N,3]]=0;
        End;
      Function Moje(N:Byte):Boolean;
        Begin
          Moje:=(Pole[MlynS[N,1]]<>2) And (Pole[MlynS[N,2]]<>2) And
            (Pole[MlynS[N,3]]<>2);
        End;
      Procedure Test(I,J:Byte);
        Begin
          If Test0(I) And Prazdne(J) Then Begin
            Pp:=I;I:=J;J:=Pp;
          End Else
            If Not(Test0(J) And Prazdne(I)) Then Exit;
            If (Pole[MlynS[J,1]]=F) Or (Pole[MlynS[J,3]]=F) Then Pp:=2
              Else Begin
                Pp:=1;
              End;
            P1:=MlynS[I,Pp];
            If T<19 Then Begin
              Mlyn:=True;Exit;
            End;
            P2:=P1;
            P1:=OdkialN(P2);
            Mlyn:=(P1 In [1..24]);
            If Mlyn And (T>18) And (F=2) Then Mlyn:=MozeSuper(P2,0);
        End;
      Begin
        For I:=13 To 16 Do
          If I In [13,15] Then
            For J:=1 To 6 Do Begin
              If Moje(M[J]) Then
                Begin
                  Test(I,P[J]);
                  If Mlyn Then Exit;
                End;
            End
          Else For J:=7 To 12 Do If Moje(M[J]) Then
            Begin
              Test(I,P[J]);
              If Mlyn Then Exit;
            End;
      End;

    Procedure TestujW1(F:Byte);
      Const P:Array [1..12] Of Byte=(4,8,12,10,6,2,1,5,9,11,7,3);
            M:Array [1..12] Of Byte=(14,14,14,16,16,16,13,13,13,15,15,15);
      Var Pp,I,J:Byte;
      Function Test0(N:Byte):Boolean;
        Begin
          Test0:=Pole[MlynS[N,1]]+Pole[MlynS[N,2]]+Pole[MlynS[N,3]]=F;
        End;
      Function Moje(N:Byte):Boolean;
        Begin
          Moje:=(Pole[MlynS[N,1]]<>2) And (Pole[MlynS[N,2]]<>2) And
            (Pole[MlynS[N,3]]<>2);
        End;
      Procedure Test(I,J:Byte);
        Begin
            If Not(Test0(J) And Test0(I)) Then Exit;
            If (Pole[MlynS[J,1]]=F) Or (Pole[MlynS[J,3]]=F) Then Pp:=2
              Else Begin
                Pp:=3;
              End;
            P1:=MlynS[J,Pp];
            If T<19 Then Begin
              Mlyn:=True;Exit;
            End;
            P2:=P1;
            P1:=OdkialN(P2);
            Mlyn:=(P1 In [1..24]);
            If Not(Mlyn) And (Pp=3) Then Begin
              If (Pole[MlynS[I,1]]=F) Or (Pole[MlynS[I,3]]=F) Then Pp:=2
                Else Pp:=3;
              P2:=MlynS[I,Pp];
              P1:=OdkialN(P2);
              Mlyn:=(P1 In [1..24]);
              If Mlyn And (T>18) And (F=2) Then Mlyn:=MozeSuper(P2,0);
            End;
        End;
      Begin
        For I:=13 To 16 Do
          If I In [13,15] Then
            For J:=1 To 6 Do Begin
              If Moje(M[J]) Then
                Begin
                  Test(I,P[J]);
                  If Mlyn Then Exit;
                End;
            End
          Else For J:=7 To 12 Do If Moje(M[J]) Then
            Begin
              Test(I,P[J]);
              If Mlyn Then Exit;
            End;
      End;

    Begin

      If T=1 Then Begin
        P1:=10;Exit;
      End;

      If T=2 Then Begin
        Testuj2(2);
        If Mlyn And Not(Nemozno(P1,P2)) Then Exit;
        Mlyn:=False;
      End;

      If T=3 Then
        If Pole[2]=2 Then Begin
          P1:=14;Exit;
        End;

      If T=3 Then Begin
        If (Pole[17]=0) And (Pole[18]=0) And (Pole[19]=0) And
          (Pole[2]=0) And (Pole[20]=0) And (Pole[21]=0) Then
        Begin P1:=20;Exit;End;
        If (Pole[17]=0) And (Pole[18]=0) And (Pole[19]=0) And
          (Pole[2]=0) And (Pole[24]=0) And (Pole[23]=0) Then
        Begin P1:=24;Exit;End;
      End;

      JeMojMlyn; {test, ci mozem uzavriet mlyn}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit; {ak ano, uzavri}

      JeMlyn;{test, ci mozno zablokovat superov mlyn}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit; {ak hej, blokuj}

      If T=5 Then Begin
        P1:=0;
        If (Pole[24]=1) And (Pole[17]=0) And (Pole[18]=0) Then P1:=17;
        If (Pole[20]=1) And (Pole[19]=0) And (Pole[18]=0) Then P1:=19;
        If P1>0 Then Exit;
      End;

      P1:=0;P2:=0;

      TestujL(1);{test, ci nemozno utvorit L-ko}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit;

      TestujL(2);{test, ci super nemoze utvorit L-ko}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit;

      TestujW1(1); {test na dokoncenie W}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit;

      TestujW1(2); {test na dokoncenie superovho W}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit;

      TestujW(1);{test na utvorenie W}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit;

      TestujW(2);{test na utvorenie W u supera - zabranit}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit;

      Testuj2(1);{test, ci moze utvorit dvojicu}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit;

      Testuj2(2);{test, ci super nemoze vytvorit dvojicu}
      If Mlyn And Not(Nemozno(P1,P2)) Then Exit;

      {inak - RANDOM !}

      If T<19 Then Begin
        P1:=Random(24)+1;
        While Pole[P1]<>0 Do P1:=Random(24)+1;
        Exit;
      End;

      P1:=Random(24)+1;P2:=Random(24)+1;
      While Nemozno(P1,P2) Do Begin
        P1:=Random(24)+1;P2:=Random(24)+1;
      End;

    End;

End.