Program S_Mlyn;

Uses Crt,Dos,Graph,SMl1,SMl2,SMl3,SMl4,SMl5,SMl6,SMl7;

Const BGIpath=''; {cesta k BGI}
      MaxTah=80;  {max. cislo tahu}
      Pauza=0;  {pauza 500ms za kazdym tahom}

Type Krok=Procedure(Pole:P;         {hracie pole}
                    T:Integer;      {cislo tahu}
                    Var P1,P2:Byte);{posun z P1 na P2 - ak T>18,inak P1-polozit}

Var Zn:Char;
    H1,H2:Krok;   {hrac 1 a 2 - procedury}
    C1,C2:Byte;   {cislo hraca 1 a 2}
    Gd,Gm:Integer;{graficky mod a rezim}

    Pole:P;       {pole}
    T:Integer;    {cislo tahu}
    T1,T2:LongInt;{cas 1 a 2 hraca}
    P1,P2:Byte;

Procedure Vymen(Var V1,V2;N:Byte);
  {sluzi na vymenu dvoch premennych dlzky N}
  Var P:Array [0..24] Of Byte;
  Begin
    Move(V1,P,N);
    Move(V2,V1,N);
    Move(P,V2,N);
  End;

Procedure Hraj;

  Var Tm:LongInt;          {pomocny cas}
      Mlyn,Koniec:Boolean; {ci ma niekto mlyn/ci je koniec hry}
      Kto,F1:Byte;         {kto vyhral}
      Pole2:P;             {pole pre 2. hraca}

  Function TimeMs:Longint;
    Var H,M,S,S100:Word;
    Begin
      GetTime(H,M,S,S100);
      TimeMs:=S100+S*100+M*6000+H*360000;
    End;

  Procedure KresliPlan;
    Var I:Byte;
    Procedure Kresli(I:Byte);
      Var X,Y:Byte;
      Begin
        X:=I*30;Y:=I*25;
        Circle(160-X,100,5);Circle(160+X,100,5);
        Circle(160-X,100-Y,5);Circle(160+X,100-Y,5);
        Circle(160-X,100+Y,5);Circle(160+X,100+Y,5);
        Circle(160,100+Y,5);Circle(160,100-Y,5);
        Line(165-X,100-Y,155,100-Y);Line(165,100-Y,155+X,100-Y);
        Line(165-X,100+Y,155,100+Y);Line(165,100+Y,155+X,100+Y);
        Line(160-X,104-Y,160-X,96);Line(160-X,104,160-X,96+Y);
        Line(160+X,104-Y,160+X,96);Line(160+X,104,160+X,96+Y);
        If I>1 Then Begin
          Line(165-X,100,185-X,100);Line(155+X,100,135+X,100);
          Line(160,104-Y,160,121-Y);Line(160,96+Y,160,79+Y);
        End;
      End;
    Begin
      ClearDevice;
      SetColor(3);
      For I:=1 To 3 Do Kresli(I);   {vykreslenie pola}
      For I:=1 To 24 Do Pole[I]:=0; {vynulovanie pola}
    End;

  Procedure Sprava(S:String);
    Begin
      SetFillStyle(1,3);Bar(0,191,319,199);
      SetColor(0);
      OutTextXY(8,192,S);
    End;

  Procedure Tahaj(H,Z,Na:Byte);
    Procedure Kruzok(C,H:Byte);
      Function X(N:Byte):Word;
        Begin
          Case N Of
            1,2,3:X:=70;
            9,10,11:X:=100;
            17,18,19:X:=130;
            4,8,12,16,20,24:X:=160;
            21,22,23:X:=190;
            13,14,15:X:=220;
            5,6,7:X:=250;
          End;
        End;
      Function Y(N:Byte):Byte;
        Begin
          Case N Of
            1,7,8:Y:=25;
            9,15,16:Y:=50;
            17,23,24:Y:=75;
            2,6,10,14,18,22:Y:=100;
            19,20,21:Y:=125;
            11,12,13:Y:=150;
            3,4,5:Y:=175;
          End;
        End;
      Begin
        SetColor(3);
        SetFillStyle(1,H);
        FloodFill(X(C),Y(C),3);
      End;

    Function Test(C1,C2,C3:Byte):Boolean;
      Begin
        Test:=(Pole[C1]=H) And (Pole[C2]=H) And (Pole[C3]=H);
      End;

    Function Nemozno(Z,Na:ShortInt):Boolean;
      Begin
        Nemozno:=False;
        If (Z-Na=1) And (Z In [9,17]) Then Begin
          Nemozno:=True;Exit;End;
        If (Na-Z=1) And (Na In [9,17]) Then Begin
          Nemozno:=True;Exit;End;
        If Abs(Z-Na)=1 Then Exit;
        If (Abs(Z-Na)=8) And (Z Mod 2=0) Then Exit;
        If (Z In [1,9,17]) And (Na-Z=7) Then Exit;
        If (Na In [1,9,17]) And (Z-Na=7) Then Exit;
        Nemozno:=True;
      End;

    Begin
      If (Z<1) Or (Z>24) Or ((T>18) And ((Na<1) Or (Na>24))) Then Begin
        Koniec:=True;
        Kto:=3-H;
        Exit;
      End;
      If T<19 Then
        If Pole[Z]>0 Then Begin
          Kto:=3-H;     {vyhral hrac 3-H}
          Koniec:=True; {koniec hry}
        End Else Begin
          Pole[Z]:=H;   {umiestnit na pole Z}
          Kruzok(Z,H);
        End
      Else
        If (Pole[Z]<>H) Or (Pole[Na]<>0) Or Nemozno(Z,Na) Then Begin
          Kto:=3-H;
          Koniec:=True;
        End Else Begin
          Pole[Z]:=0;   {premiestnit z pola Z}
          Kruzok(Z,0);  {na pole Na}
          Pole[Na]:=H;
          Kruzok(Na,H);
        End;
      If Test(1,2,3) Or Test(3,4,5) Or Test(5,6,7) Or Test(7,8,1) Or
         Test(9,10,11) Or Test(11,12,13) Or Test(13,14,15) Or Test(15,16,9) Or
         Test(17,18,19) Or Test(19,20,21) Or Test(21,22,23) Or Test(23,24,17) Or
         Test(2,10,18) Or Test(8,16,24) Or Test(6,14,22) Or Test(4,12,20)
      Then Begin
        Mlyn:=True;
        Kto:=H;
      End;
    End;

  Procedure HrajHru;

    Var I:Byte;
        S:String;

    Begin

      KresliPlan;

      Sprava('Stlac lubovolny klaves na zacatie hry !');
      Zn:=ReadKey;If Zn=#0 Then Zn:=ReadKey;
      T:=1;          {prvy tah};
      Mlyn:=False;   {nik nema mlyn}
      Koniec:=False; {nie je koniec hry}
      Kto:=0;P1:=0;P2:=0;
       {nik nevyhral; na zac. su nezmyselne suradnice supera}
      Sprava('Hram . . .');

      Repeat

        Tm:=TimeMs;
        H1(Pole,T,P1,P2); {to je tah 1. hraca}
        T1:=T1+TimeMs-Tm;
        Tahaj(1,P1,P2);

        Inc(T); {pripocitanie tahu}

        Delay(Pauza);
        If Pauza=0 Then Zn:=ReadKey;

        If Not(Koniec Or Mlyn) Then Begin

          For I:=1 To 24 Do  {pretransformovanie pola}
            Case Pole[I] Of  {pre druheho hraca}
              1:Pole2[I]:=2;
              2:Pole2[I]:=1;
              Else Pole2[I]:=0;
            End;

          Tm:=TimeMs;
          H2(Pole2,T,P1,P2);{to je tah 2. hraca}
          T2:=T2+TimeMs-Tm;
          Tahaj(2,P1,P2);

          Inc(T); {pripocitanie tahu}

          Delay(Pauza);
          If Pauza=0 Then Zn:=ReadKey;

          If KeyPressed Then Begin
            Zn:=ReadKey;
            If Zn=#27 Then Koniec:=True;
          End;

        End;

      Until Mlyn Or (T>=MaxTah) Or Koniec;

      If Kto=1 Then Begin
        Str(C1,S);
        Kto:=C1;
      End Else Begin
        Str(C2,S);
        Kto:=C2;
      End;

      If (Kto=0) Then S:='Remiza... Prekroceny max.pocet tahov !'
       Else Begin
         S:='Vyhral hrac c. '+S;
         If Mlyn Then S:=S+'. Vytvoril mlyn.' Else S:=S+'. Nespravny tah.';
       End;
      Sprava(S);
      Zn:=ReadKey;If Zn=#0 Then Zn:=ReadKey;

    End;

  Begin

    {inicializacia grafiky}
    Gd:=CGA;Gm:=CGAC0;
    InitGraph(Gd,Gm,BGIpath);
    T1:=0;T2:=0; {cas 1 a 2 hraca}

    {samotna hra}
    HrajHru;
    F1:=Kto;

    {vymena stran}
    Vymen(C1,C2,1);
    Vymen(H1,H2,4);
    Vymen(T1,T2,4);

    HrajHru;

    CloseGraph;

    If F1=Kto Then Begin
      TextAttr:=14;
      WriteLn('Totalne vitazstvo druzstva c. ',Kto);
    End Else Begin
      TextAttr:=7;
{      WriteLn('Neplatne:');
      Write('Vyhralo druzstvo c. ');
      If T1<T2 Then Write(C1)
        Else If T2<T1 Then Write(C2) Else Begin
          ClrScr;
          Write('Remiza');
        End;
      WriteLn(', ale bolo to len o chlp !');
      TextAttr:=11;
      WriteLn('Platne:');}
      WriteLn('Remiza . . .');
    End;

  End;

Begin

  DirectVideo:=False; {vypis cez BIOS}

  Repeat

    TextAttr:=7;ClrScr;
    TextAttr:=14;

    WriteLn('*************************************');
    WriteLn('* S-Mlyn       letne sustr. KSP ''91 *');
    WriteLn('*************************************');
    WriteLn;

    TextAttr:=11;
    Write('Prvy hrac:');
    Repeat Zn:=ReadKey;Until Zn In ['1'..'7',#27];
    WriteLn(Zn);WriteLn;
    If Zn=#27 Then Exit;
    C1:=Ord(Zn)-48;

    Write('Druhy hrac:');
    Repeat Zn:=ReadKey;Until Zn In ['1'..'7',#27];
    WriteLn(Zn);WriteLn;
    If Zn=#27 Then Exit;
    C2:=Ord(Zn)-48;

    {priradenie prveho hraca}
    Case C1 Of
      1:@H1:=@SMl1.Tah;
      2:@H1:=@SMl2.Tah;
      3:@H1:=@SMl3.Tah;
      4:@H1:=@SMl4.Tah;
      5:@H1:=@SMl5.Tah;
      6:@H1:=@SMl6.Tah;
      7:@H1:=@SMl7.Tah;
    End;

    {priradenie druheho hraca}
    Case C2 Of
      1:@H2:=@SMl1.Tah;
      2:@H2:=@SMl2.Tah;
      3:@H2:=@SMl3.Tah;
      4:@H2:=@SMl4.Tah;
      5:@H2:=@SMl5.Tah;
      6:@H2:=@SMl6.Tah;
      7:@H2:=@SMl7.Tah;
    End;

    Hraj;

    TextAttr:=7;
    WriteLn('Este raz ? [A/N]');
    Repeat Zn:=UpCase(ReadKey);Until Zn In ['A','N',#27];

  Until Zn<>'A';

  TextAttr:=14;
  WriteLn('Dovidenia !!!');

End.